﻿jQuery.fn.updateWithText = function(text, speed)
{
	var dummy = $('<div/>').html(text);

	if ($(this).html() != dummy.html())
	{
		$(this).fadeOut(speed/2, function() {
			$(this).html(text);
			$(this).fadeIn(speed/2, function() {
				//done
			});
		});
	}
}

jQuery.fn.outerHTML = function(s) {
    return s
        ? this.before(s).remove()
        : jQuery("<p>").append(this.eq(0).clone()).html();
};

function roundVal(temp)
{
	return Math.round(temp * 10) / 10;
}

jQuery(document).ready(function($) {

	var news = [];
	var newstext = [];
	var newsIndex = 0;
	var eventList = [];

    moment.locale(lang);

	(function updateTime()
	{
        var now = moment();
        var date = now.format('LLLL').split(' ',4);
        date = date[0] + ' ' + date[1] + ' ' + date[2] + ' ' + date[3];

		$('.date').html(date);
		$('.time').html(now.format('HH') + ':' + now.format('mm') + '<span class="sec">'+now.format('ss')+'</span>');

		setTimeout(function() {
			updateTime();
		}, sekund);
	})();

	(function updateCurrentWeather()
	{
		var iconTable = {
			'01d':'wi-day-sunny',
			'02d':'wi-day-cloudy',
			'03d':'wi-cloudy',
			'04d':'wi-cloudy-windy',
			'09d':'wi-showers',
			'10d':'wi-rain',
			'11d':'wi-thunderstorm',
			'13d':'wi-snow',
			'50d':'wi-fog',
			'01n':'wi-night-clear',
			'02n':'wi-night-cloudy',
			'03n':'wi-night-cloudy',
			'04n':'wi-night-cloudy',
			'09n':'wi-night-showers',
			'10n':'wi-night-rain',
			'11n':'wi-night-thunderstorm',
			'13n':'wi-night-snow',
			'50n':'wi-night-alt-cloudy-windy'
		}

		$.getJSON('http://api.openweathermap.org/data/2.5/weather', weatherParams, function(json, textStatus) {

			var temp = roundVal(json.main.temp);
			var temp_min = roundVal(json.main.temp_min);
			var temp_max = roundVal(json.main.temp_max);

			var wind = roundVal(json.wind.speed);

			var iconClass = iconTable[json.weather[0].icon];
			var icon = $('<span/>').addClass('icon').addClass('wi').addClass(iconClass);
			$('.temp').updateWithText(icon.outerHTML()+temp+'&deg;', 1000);

			var now = new Date();
			var sunrise = new Date(json.sys.sunrise*1000).toTimeString().substring(0,5);
			var sunset = new Date(json.sys.sunset*1000).toTimeString().substring(0,5);

			var windString = '<span class="wi wi-strong-wind"></span> ' + wind ;
			var sunString = '<span class="wi wi-sunrise"></span> ' + sunrise;
			if (json.sys.sunrise*1000 < now && json.sys.sunset*1000 > now) {
				sunString = '<span class="wi wi-sunset"></span> ' + sunset;
			}

			$('.windsun').updateWithText(windString+' '+sunString, 1000);
		});

		setTimeout(function() {
			updateCurrentWeather();
		}, ufWeather); 
	})();

	(function updateWeatherForecast()
	{
		var iconTable = {
			'01d':'wi-day-sunny',
			'02d':'wi-day-cloudy',
			'03d':'wi-cloudy',
			'04d':'wi-cloudy-windy',
			'09d':'wi-showers',
			'10d':'wi-rain',
			'11d':'wi-thunderstorm',
			'13d':'wi-snow',
			'50d':'wi-fog',
			'01n':'wi-night-clear',
			'02n':'wi-night-cloudy',
			'03n':'wi-night-cloudy',
			'04n':'wi-night-cloudy',
			'09n':'wi-night-showers',
			'10n':'wi-night-rain',
			'11n':'wi-night-thunderstorm',
			'13n':'wi-night-snow',
			'50n':'wi-night-alt-cloudy-windy'
		}
		$.getJSON('http://api.openweathermap.org/data/2.5/forecast/daily', weatherParams, function(json, textStatus) {

			var forecastData = {};

			for (var i in json.list) {
				var forecast = json.list[i];
				var dateKey  = forecast.dt;

				forecastData[dateKey] = {
					'timestamp':forecast.dt*1000,
					'icon':forecast.weather[0].icon,
					'temp_min':forecast.temp.night,
					'temp_max':forecast.temp.day
				};
			}

			var forecastTable = $('<table />').addClass('forecast-table');
			var opacity = 1;
			for (var i in forecastData) {
				var forecast = forecastData[i];
			    var iconClass = iconTable[forecast.icon];
				var dt = new Date(forecast.timestamp);
				var row = $('<tr />').css('opacity', opacity);

				row.append($('<td/>').addClass('day small').html(moment.weekdaysShort(dt.getDay())));
				row.append($('<td/>').addClass('icon-small small').addClass('wi').addClass(iconClass));
				row.append($('<td/>').addClass('temp-max small').html(roundVal(forecast.temp_max)));
				row.append($('<td/>').addClass('temp-min small').html(roundVal(forecast.temp_min)));

				forecastTable.append(row);
				opacity -= 0.155;
			}

			$('.forecast').updateWithText(forecastTable, 1000);
		});

		setTimeout(function() {
			updateWeatherForecast();
		}, ufForecast);
	})();

	(function fetchNews() 
	{
		$.getJSON('http://mirror01/xml2json/xml2json.php', newsParams, function(json, textStatus) {
			news = [];
			newstext = [];
			for (var i in json.channel.item) {
				var item = json.channel.item[i];
				news.push(item.title);
				newstext.push(item.description);
			}
		});
		setTimeout(function() {
			fetchNews();
		},uffetchNews);
	})();

	(function showNews() 
	{
		var newsItem = news[newsIndex];
		var newstextItem = newstext[newsIndex];
		$('.news').updateWithText(newsItem,2000);
		$('.newstext').updateWithText(newstextItem,2000);
		
		newsIndex--;
		if (newsIndex < 0) newsIndex = news.length - 1;
		setTimeout(function() {
			showNews();
		},ufshowNews);
	})();
	
	(function updateCalendar()
	{
		var calendarTable = $('<table />').addClass('calendar-table');
		$.getJSON('http://mirror01/gcal/index.php', calendarParams, function(json, textStatus) {
			for (var i in json) {
				var eventData = json[i];
				if (eventData.eventTimeStart != "") {
					var eventTime = ' <span class="xxsmall">(' + eventData.eventTimeStart + " - " + eventData.eventTimeEnd + ')</span>';
				} else {
					var eventTime = "";
				}
				var row = $('<tr />');
				row.append($('<td/>').addClass('small').html(eventData.eventDate));
				row.append($('<td/>').addClass('small').html(eventData.summary+eventTime));
				calendarTable.append(row);
			}
			$('.calendar').updateWithText(calendarTable, 1000);
		});
		setTimeout(function() {
			updateCalendar();
		},ufCalendar);
	})();

	(function updateQuote() 
	{
		$.getJSON('http://mirror01/xml2json/xml2json.php', quoteParams, function(json, textStatus) {
			$('.quote').updateWithText(json.channel.item.description,2);
			$('.quoteauthor').updateWithText(json.channel.item.title,2);
		});
		setTimeout(function() {
			updateQuote();
		},ufQuote);
	})();
});
